# HttpRequestTask

Extends \HttpTask

A HTTP request task.

Making an HTTP request and try to match the response against an provided regular expression.

package | phing.tasks.ext
author | Benjamin Schultz bschultz@proqrent.de
version | $Id: ab6a2d3903492a67c2a16f15ae667d8866af6c1e $
since | 2.4.1

### Methods

## Creates a config parameter for this task

    createConfig() : \Parameter

inherited

### Response

`\Parameter`

The created config parameter

## Creates an additional header for this task

    createHeader() : \Parameter

inherited

### Response

`\Parameter`

The created header

## Creates post body parameters for this request

    createPostParameter() : \Parameter

### Response

`\Parameter`

The created post parameter

## Creates and configures an instance of HTTP_Request2

    createRequest() : \HTTP_Request2

inherited

### Response

`\HTTP_Request2`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Processes the server's response

    processResponse(\HTTP_Request2_Response $response) : void

inherited abstract

throws |

### Arguments

#### $response

`\HTTP_Request2_Response`

## Sets the authentication password

    setAuthPassword(string $password)

inherited

### Arguments

#### $password

`string`

## Sets the authentication scheme

    setAuthScheme(string $scheme)

inherited

### Arguments

#### $scheme

`string`

## Sets the authentication user name

    setAuthUser(string $user)

inherited

### Arguments

#### $user

`string`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## The setter for the method

    setMethod( $method)

### Arguments

#### $method

``

## Sets a list of observer events that will be logged if verbose output is enabled.

    setObserverEvents(string $observerEvents)

### Arguments

#### $observerEvents

`string`

List of observer events

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the prototype object that will be cloned in createRequest()

    setRequestPrototype(\HTTP_Request2 $request)

inherited

Used in tests to inject an instance of HTTP_Request2 containing a custom adapter

### Arguments

#### $request

`\HTTP_Request2`

## Sets the response regex

    setResponseRegex(string $regex)

### Arguments

#### $regex

`string`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets the request URL

    setUrl(string $url)

inherited

### Arguments

#### $url

`string`

## Sets whether to enable detailed logging

    setVerbose(boolean $verbose)

### Arguments

#### $verbose

`boolean`

### Properties

## Holds the regular expression that should match the response

    responseRegex : string

var |

### Type(s)

`string`

## Whether to enable detailed logging

    verbose : boolean

var |

### Type(s)

`boolean`

## Holds the events that will be logged

    observerEvents : \array<string>

var |

### Type(s)

`\array`

## Holds the request method

    method : string

var |

### Type(s)

`string`

## Holds additional post parameters for the request

    postParameters : array<mixed,\Parameter>

var |

### Type(s)

`array<mixed,\Parameter>`

## Holds the request URL

    url : string

inherited

var |

### Type(s)

`string`

## Prototype HTTP_Request2 object, cloned in createRequest()

    requestPrototype : \HTTP_Request2

inherited

var |

### Type(s)

`\HTTP_Request2`

## Holds additional header data

    headers : array<mixed,\Parameter>

inherited

var |

### Type(s)

`array<mixed,\Parameter>`

## Holds additional config data for HTTP_Request2

    configData : array<mixed,\Parameter>

inherited

var |

### Type(s)

`array<mixed,\Parameter>`

## Holds the authentication user name

    authUser : string

inherited

var |

### Type(s)

`string`

## Holds the authentication password

    authPassword : string

inherited

var |

### Type(s)

`string`

## Holds the authentication scheme

    authScheme : string

inherited

var |

### Type(s)

`string`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`